#include "stdio.h"
#define END 0xff
#define ERROR 0
#define CPMEOF 0X1A
#define UPPER 0
#define LOWER 1
#define WORDS -1
#define NULL 0
#define DeSmet 1


/***********************************************************************/
/*								       */
/*	The following are specific for the IBM PC.			   */
/*								       */
/***********************************************************************/

#define 	REVVID	0x70	/* reverse video attribute */
#define 	NORM	0x07	/* normal video attribute */

/***********************************************************************/
/*								       */
/*	Miscellaneous ASCII characters					   */
/*								       */
/***********************************************************************/

#define 	ESC	0x1b	/* escape code */
#define 	TAB	9
#define 	LF	10
#define 	CR	13
#define 	CTRLZ	26	/* eof char */
#define 	NULL	0x00	/* null char */
#define 	EOS	0x00	/* end of string */

char strbuf[20];
int  charcnt = 0;

char	*documentation[] = {
"cntlfile builds control character files from the keyboard.",
"   cntlfile [flags] [>file]",
"",
"Flags are single characters preceeded by '-':",
"   none are yet defined.",
"",
"Input is from the console. Simply press the keys.",
"   End by holding CTRL down and pressing Z.",
"Output is to stdout.  To print, add >PRN: to your command.",
"   To send to a file, add >filename to your command.",
0 };

int debug = 0;


main(argc, argv)
char *argv[];
{
   register char   *p;
   register int    c, i;
	int nfile;
	char tolower();
   FILE 	   *f;

   clrscr();

   if (argc == 2 && argv[1][0] == '?' && argv[1][1] == 0) {
      help(documentation);
      return;
      }
   nfile = argc-1;
   for (i=1; i < argc; ++i) {
      p = argv[i];
      if (*p == '-') {
	 ++p;
	 while (c = *p++) {
	    switch(tolower(c)) {

	    case '?':
	       help(documentation);
	       break;

	    case 'D':
	    case 'd':
	       debug++;
	       break;


	    default:
	       usage("Unknown flag");
	    }
	 }
	 argv[i] = 0;
	 --nfile;
      }
   }
	if (nfile == 0)
		cntlfile(0);
	else
		usage("Input from the console only");
}


/*******************************************************/

usage(s)
char	*s;
{
   conout("?cntlfile-E-",NORM);
   conout(s,NORM);
   conout("\n",NORM);
   conout("Usage: cntlfile [>file].  \n",NORM);
   conout(" cntlfile ? for help\n",NORM);
   exit(1);
}


/*******************************************************/

error(s)	/* special version of error to use console direct i/o */
char *s;
{
   conout(s,NORM);
   exit(1);
}


/*******************************************************/

cntlfile(fn)
char	   *fn;       /* File name (not used to date)  */
/*
 * send the keyboard input directly to the output file.
 */
{
	char c, ci(), putc();

	conout("Press required keys. ",NORM);
	conout("To end, hold down CTRL and press Z.\n\n",NORM);

	while (((c = ci()) != CPMEOF) && (c != END)) {
			putc(c,stdout);
			kbecho(c);
	}
}

dismod()
{
	scr_setup();
	return;
}



clrscr()
{
	scr_clr();
}


conout(s,attr)
char *s;
int attr;
{
	scr_aputs(s,attr);
}
